#!/bin/bash
#'autossh -i /root/.ssh/id_rsa -M 0 -o "ServerAliveInterval 30" -o "ServerAliveCountMax 3" -NR ' + str(offered_slot) + ':localhost:22 root@hive.hrig.tech -p 22020 >> /root/sshtun.log 2>> /root/sshtun.err &'

#ssh -i .ssh/stateless_rsa -R 1194:localhost:1194 stateless_agent@horslan.ddbuiq.tech -p 22016

SSH_USER='stateless_agent'
SSH_USERID='stateless_rsa'
#SSH_REMOTE='horslan.ddbuiq.tech'
SSH_REMOTE='browserstack.ddbuiq.tech'

VpnTUN_LOCAL_PORT='1194'
VpnTUN_REMOTE_PORT='1194'
WebTUN_LOCAL_PORT='80'
WebTUN_REMOTE_PORT='2280'
SshTUN_LOCAL_PORT='22'
SshTUN_REMOTE_PORT='22'

function init_colors () {
	C_NC='\e[0m' # No Color
	C_BLACK='\e[0;30m'
	C_GRAY='\e[1;30m'
	C_RED='\e[0;31m'
	C_LIGHT_RED='\e[1;31m'
	C_GREEN='\e[0;32m'
	C_LIGHT_GREEN='\e[1;32m'
	C_BROWN='\e[0;33m'
	C_YELLOW='\e[1;33m'
	C_BLUE='\e[0;34m'
	C_LIGHT_BLUE='\e[1;34m'
	C_PURPLE='\e[0;35m'
	C_LIGHT_PURPLE='\e[1;35m'
	C_CYAN='\e[0;36m'
	C_LIGHT_CYAN='\e[1;36m'
	C_LIGHT_GRAY='\e[0;37m'
	C_WHITE='\e[1;37m'
	BG_GREEN='\033[1;102m'
	BG_RED='\e[1;101m'
	BG_WHITE='\e[30;107m'
	BG_YEL='\e[30;103m'
}

function subBroadcast () {
	date=$(date)
	echo -e $C_LIGHT_GREEN'##\t '$1$C_NC
	echo -e $date' ''##\t '$1 >> /root/logs/sshtun.log
}

function getLastSeenOVPNClients () {
	clientConnected=$(cat /var/log/openvpn/status.log | grep -B 3 'ROUTING TABLE' | grep -i 'entosis-regw-')

	lastSeen=500
	if [[ $clientConnected != '' ]]; then
		clientName=$(echo $clientConnected | awk -F, '{print $1}')
		clientPort=$(echo $clientConnected | awk -F, '{print $2}' | awk -F: '{print $2}')
		clientRx=$(echo $clientConnected | awk -F, '{print $3}')
		clientTx=$(echo $clientConnected | awk -F, '{print $4}')
		clientConSince=$(echo $clientConnected | awk -F, '{print $5}')
		clientLastSeen=$(cat /var/log/openvpn/status.log | grep -A 3 'ROUTING TABLE' | grep -i $clientName | awk -F, '{print $4}')

		#echo "since: '${clientConSince}'"
		#echo "Seen: '${clientLastSeen}'"

		nowEpoch=$(date +"%s")
		clientLastSeenEpoch=$(date -d "$clientLastSeen" +"%s")
		lastSeen=$((nowEpoch-clientLastSeenEpoch))
	fi

	echo $lastSeen
}

function asshat_disconnect () {
	__lport=$1
	__rport=$2
	__host=$3
	__user=$4
	__serviceName=$5
	pgrep -af autossh | while read -r pid cmd; do
                techStuff=$(echo $cmd | awk -F'NR ' '{print$2}')
                remotePort=$(echo $techStuff | awk -F':' '{print $1}')
                localPort=$(echo $techStuff | awk -F':' '{print $3}' | awk '{print $1}')
                user=$(echo $techStuff | awk -F'@' '{print $1}' | awk '{print $2}')
                host=$(echo $techStuff | awk -F'@' '{print $2}' | awk '{print $1}')

		if [[ $remotePort == $__rport ]] && [[ $localPort == $__lport ]] && [[ $user == $__user ]] && [[ $host == $__host ]]; then
			subBroadcast "${__serviceName}: ${lastSeen} <300 sec - No need SSH Tunnel - Killing it (pid: ${pid})"
			kill -9 $pid
		#else
		#	echo "${__serviceName} Not matching"
		fi
	done
}

function asshat_connect () {
	__SSH_REMOTE=$1
	__SSH_PORT=$2
	__SSH_USER=$3
	__SSH_USERID=$4
	__TUN_REMOTE_PORT=$5
	__TUN_LOCAL_PORT=$6
	__TUN_DESC=$7

	BridgeProcess=$(ps -aux | grep -i '/usr/lib/autossh/autossh' | grep -ic ${__TUN_REMOTE_PORT})

	if [[ $__TUN_DESC != '' ]]; then __TUN_DESC=$(echo $__TUN_DESC' '); fi

	if [[ $BridgeProcess -eq 0 ]]; then
		subBroadcast "[${__TUN_DESC}Bridge] is NOT Connected - Connecting to remote Host..."
		/usr/bin/autossh -i /root/.ssh/${__SSH_USERID} -M 0 -o "ServerAliveInterval 30" -o "ServerAliveCountMax 3" -NR ${__TUN_REMOTE_PORT}:localhost:${__TUN_LOCAL_PORT} ${__SSH_USER}@${__SSH_REMOTE} -p ${__SSH_PORT} >> /root/logs/sshtun.log 2>> /root/logs/sshtun.err &

		sleep 2
		BridgeProcess=$(ps -aux | grep -i '/usr/lib/autossh/autossh' | grep -ic ${__TUN_REMOTE_PORT})

		if [[ $BridgeProcess -eq 0 ]]; then
			subBroadcast "[${__TUN_DESC}Bridge] Connexion FAILED!"
			subBroadcast "SSH_REMOTE=${__SSH_REMOTE}"
			subBroadcast "SSH_PORT=${__SSH_PORT}"
			subBroadcast "SSH_USER=${__SSH_USER}"
			subBroadcast "SSH_TUN_REM=${__TUN_REMOTE_PORT}"
			subBroadcast "SSH_TUN_LOC=${__TUN_LOCAL_PORT}"
			#subBroadcast "SSH_=${__SSH_REMOTE}"
		else
			subBroadcast "[${__TUN_DESC}Bridge] Success!"
		fi
	else
		subBroadcast "[${__TUN_DESC}Bridge] is Connected to remote Host!"
	fi

}

SSH_PORT=''
case $(hostname) in
	vlu-mini-nuc )
		SSH_PORT='22010'
		;;
	vlu-entosis-regw-1 )
		SSH_PORT='22016'
		;;
	vlu-entosis-regw-2 )
		SSH_PORT='22020'
		;;
	* )
		#subBroadcast_error "[OVPNC] Error: Could not define target host from hostname '$(hostname)'"
		exit 1;
		;;
esac

if [[ $SSH_PORT != '' ]]; then
	# Bind OVPN Bridge
	asshat_connect $SSH_REMOTE $SSH_PORT $SSH_USER $SSH_USERID $VpnTUN_REMOTE_PORT $VpnTUN_LOCAL_PORT "VPN"

	# Bind WebServer Output to 2280
	asshat_connect $SSH_REMOTE $SSH_PORT $SSH_USER $SSH_USERID $WebTUN_REMOTE_PORT $WebTUN_LOCAL_PORT "API"

	lastSeen=$(getLastSeenOVPNClients)
	if [[ $lastSeen -ge 300 ]]; then
		subBroadcast "${lastSeen} >300 sec - starting SSH Tunnel"
		asshat_connect $SSH_REMOTE $SSH_PORT $SSH_USER $SSH_USERID $SshTUN_REMOTE_PORT $SshTUN_LOCAL_PORT "SSH"
	else
		#subBroadcast "${lastSeen} <300 sec - No need SSH Tunnel - Killing it"
		asshat_disconnect $SshTUN_LOCAL_PORT $SshTUN_REMOTE_PORT $SSH_REMOTE $SSH_USER "SSH"
	fi

	# Bind SSH Bridge
	#asshat_connect $SSH_REMOTE $SSH_PORT $SSH_USER $SSH_USERID $SshTUN_REMOTE_PORT $SshTUN_LOCAL_PORT "SSH"
fi

